#include <stdio.h>
#include <gmodule.h>

G_MODULE_EXPORT int val;

int main(int argc, char **argv) {
    gchar *module;
	GModule *gm;
	void (*the_real_pluginfunc)() = NULL;

	if (argc != 2) {
		printf("usage: %s <value>\n", argv[0]);
		exit(1);
	}

    module = g_module_build_path(LIBDIR, "plugin");
    g_message("trying to open %s\n", module);
	gm = g_module_open(module, 0);

	if (gm == NULL)
	{
        g_warning(g_module_error());
		exit(1);
	}

	if(gm && g_module_symbol(gm, "plugin_func",
                             (gpointer)&the_real_pluginfunc))
	{
		the_real_pluginfunc();
		g_module_close(gm);
		return;
	} else {
        g_warning(g_module_error());
		exit(1);
	}
}
